/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sifd;

import java.util.ArrayList;
import java.util.Date;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.PasswordField;
import javafx.scene.control.TextField;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.stage.Stage;
import org.neuroph.core.NeuralNetwork;
import org.neuroph.core.learning.SupervisedTrainingElement;
import org.neuroph.core.learning.TrainingSet;
import org.neuroph.nnet.MultiLayerPerceptron;
import org.neuroph.nnet.learning.LMS;

/**
 *
 * @author vs01149
 */
public class SiFD extends Application {

    NeuralNetwork neuralNet;
    double datamax = 1000.0D; //normalize
    BorderPane borderPane = new BorderPane();
    ArrayList arrayList = new ArrayList();
    Label message = new Label("");

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage primaryStage) {
        /**
         * training data , the word "muster" in the input feld *
         */
        /*
         * user value 100 - Larissa , user value 900 - Valentin
         */
        /*
         * Lara
         */
        double[] datal1 = {440. / datamax, 454. / datamax, 336. / datamax, 287. / datamax, 224. / datamax};
        double[] resl1 = {100. / datamax};
        double[] datal2 = {431. / datamax, 457. / datamax, 431. / datamax, 336. / datamax, 200. / datamax};
        double[] resl2 = {100. / datamax};
        double[] datal3 = {400. / datamax, 353. / datamax, 240. / datamax, 152. / datamax, 152. / datamax};
        double[] resl3 = {100. / datamax};

        double[] datav1 = {328. / datamax, 391. / datamax, 272. / datamax, 272. / datamax, 192. / datamax};
        double[] resv1 = {900. / datamax};
        double[] datav2 = {287. / datamax, 369. / datamax, 272. / datamax, 256. / datamax, 183. / datamax};
        double[] resv2 = {900. / datamax};
        double[] datav3 = {255. / datamax, 360. / datamax, 263. / datamax, 232. / datamax, 177. / datamax};
        double[] resv3 = {900. / datamax};

        TrainingSet trainingSet = new TrainingSet();
        trainingSet.addElement(new SupervisedTrainingElement(datal1, resl1));
        trainingSet.addElement(new SupervisedTrainingElement(datal2, resl2));
        trainingSet.addElement(new SupervisedTrainingElement(datal3, resl3));
        trainingSet.addElement(new SupervisedTrainingElement(datav1, resv1));
        trainingSet.addElement(new SupervisedTrainingElement(datav2, resv2));
        trainingSet.addElement(new SupervisedTrainingElement(datav3, resv3));
        int maxIterations = 10000;
        neuralNet = new MultiLayerPerceptron(5, 11, 1);
        ((LMS) neuralNet.getLearningRule()).setMaxError(0.0001);//0-1
        ((LMS) neuralNet.getLearningRule()).setLearningRate(0.60);//0-1
        ((LMS) neuralNet.getLearningRule()).setMaxIterations(maxIterations);//0-1        
        neuralNet.learn(trainingSet);
        /*
         * test from training data
         */
        neuralNet.setInput(datal1);
        neuralNet.calculate();
        double[] networkOutput = neuralNet.getOutput();
        double predicted = networkOutput[0];
        System.out.println("PREDICTED (TEST: it must be 0.1):" + predicted);

        /*
         * layout
         */
        text();
        primaryStage.setTitle("SiDF");
        primaryStage.setScene(new Scene(borderPane, 640, 400));
        primaryStage.show();

    }

    /**
     * Vbox text *
     */
    private void text() {
        final TextField textBox = new TextField();
        textBox.setPromptText("your text: muster. please type the text");
        textBox.setOnKeyPressed(new EventHandler<KeyEvent>() {

            @Override
            public void handle(KeyEvent ke) {
                Date date = new Date();
                arrayList.add(date);
                //System.out.println("Key Pressed: " + ke.getText() + " msec:" + date.getTime());
            }
        });
        textBox.setOnKeyReleased(new EventHandler<KeyEvent>() {

            @Override
            public void handle(KeyEvent ke) {
            }
        });
        textBox.setOnKeyTyped(new EventHandler<KeyEvent>() {

            @Override
            public void handle(KeyEvent ke) {
            }
        });
        
        Button btn = button();        
        final VBox vbox = new VBox();
        vbox.setSpacing(5);
        vbox.getChildren().addAll(textBox,btn,message);
        vbox.setPadding(new Insets(10, 10, 10, 10));
        borderPane.setCenter(vbox);
    }

    private Button button() {
        Button btn = new Button();
        btn.setText("Testing");
        btn.setOnAction(
                new EventHandler<ActionEvent>() {

                    @Override
                    public void handle(ActionEvent event) {
                        System.out.println("Pushed");
                        double[] testdata = new double[5];
                        for (int i = 1; i < arrayList.size(); i++) {
                            Long diff = ((Date) arrayList.get(i)).getTime() - ((Date) arrayList.get(i - 1)).getTime();
                            System.out.println(diff);
                            if (i <= 5) {
                                testdata[i - 1] = diff / datamax;
                                if (i == 5) {
                                    neuralNet.setInput(testdata);
                                    neuralNet.calculate();
                                    double[] networkOutput = neuralNet.getOutput();
                                    double predicted = networkOutput[0] * datamax;
                                    System.out.println("LIVE PREDICTED:" + predicted);
                                    double v = Math.abs(900.0 - predicted);
                                    double l = Math.abs(100.0 - predicted);
                                    if (v > l) {
                                        message.setText("Hallo Person 1!");
                                        System.out.println("Hallo Person 1!");
                                    } else {
                                        message.setText("Hallo Person 2!");
                                        System.out.println("Hallo Person 2!");
                                    }
                                    arrayList = new ArrayList();
                                }
                            }
                        }
                    }
                });
        return btn;
    }
}
